#!/usr/bin/perl

use DataOneLdap;
use strict;

use Getopt::Long();

sub usage {
   my $message = $_[0];
   if (defined $message && length $message) {
      $message .= "\n"
         unless $message =~ /\n$/;
   }

   my $command = $0;
   $command =~ s#^.*/##;

   print STDERR (
      $message,
      "usage: $command [--help] [--id nodeId] \n" 
   );

   die("\n");
}

my $nodeid;
my $all;
my $help;
my $mesg;

Getopt::Long::GetOptions(
   'id=s' => \$nodeid,
   'help!' => \$help,
) or usage("Invalid commmand line options.");
 
usage() if (defined $help);

$all = 1 unless (defined $nodeid);

my $d1Ldap = new DataOneLdap();

my $ldap = $d1Ldap->connect();

if (defined $all) 
	{
	$mesg = $ldap->search( filter=>"(objectClass=d1Node)", 
                        base=>"dc=dataone,dc=org");
	} else {
	$mesg = $ldap->search(  filter=>"(cn=$nodeid)", 
                        base=>"dc=dataone,dc=org");

	}
my @entries = $mesg->entries;
foreach my $entry (@entries) 
	{
	my $dn = $entry->dn();
	print "$dn\n";
	}

$d1Ldap->disconnect();

